/* archive read attributes.h
 *
 * This file is public domain, by W.H.Scholten 1997-2001
 */

#ifndef _BBCIM__archive_read_attributes_h
#define _BBCIM__archive_read_attributes_h


#define BBCIM_ATTR__LOCKED   1 /* DFS & TAPE */

#define BBCIM_ATTR__R        1 /* ADFS */
#define BBCIM_ATTR__W        2
#define BBCIM_ATTR__E        4
#define BBCIM_ATTR__D        8

#define BBCIM_FILETYPE__TAPE  1
#define BBCIM_FILETYPE__DISK  2

struct bbcfile {
	/* BBC filename/attributes */
	int  type; /* BBCCIM_FILETYPE_TAPE etc. */
	char *name;
	long loadaddr;
	long execaddr;
	long length;
	unsigned char attributes;
	long crc; /* 0-65535 for a valid crc, any other value denotes an invalid or no crc found; bbcim returns -1 in such a case */
	char *next_tape_file; /* host filename! */
};


enum Disktype { BBCIM_DFS_DISK, BBCIM_DDOS_DISK, BBCIM_W62_DISK, BBCIM_ADFS_DISK, BBCIM_HDFS_DISK };

struct bbcdiskimage {
	int  type; /* DFS_DISK, W62_DISK, DDOS_DISK, ADFS_DISK, HDFS_DISK */
	int  sides;
	int  tracks;
	int  sectors_per_track;
	int  bytes_per_sector;
};


int  bbcim_archive_read_file_attributes(char *filename, struct bbcfile *file, int verbose);
void bbcim_archive_free_file_attributes(struct bbcfile *file);

int  bbcim_archive_read_disk_attributes(char *diskname, struct bbcdiskimage *image, int verbose);

#endif /* _BBCIM__archive_read_attributes_h */
