/* bbctapeblocks, by W.H.Scholten 2001
 *
 * This file is released to the public domain.
 *
 * bbctapeblocks extracts files from tape blocks into the archive format.
 *
 */

#include <stdio.h>
#include <string.h>


//#define DEBUG
#ifdef DEBUG
#  define DEB(x) x
#else
#  define DEB(x)
#endif

void bbcim_replace_bad_chars(char *unix_bbcfile_naam);
int  bbcim_printable_bbcfilename(char *name);
int  bbcim_rename_sequential(char *name);
long bbcim_fcrc(char *bestand, int verbose);
long bbcim_data_crc(void *data, int length);
int  decode_tape(char *tapefile, char *extract_dir, int tape_extract, int tape_catalogue);

#define True   1
#define False  0

#include "_bbcim_code.c"
#include "_help.c"
#include "_decode_tape.c"

char *extract_directory = ".";

int main(int argc, char **argv) {
	int i;

	int tape_extract = 0;
	int tape_catalogue = 1;

	int verbose = 1;


	if (argc == 1)
		show_help();

	for (i=1; i<argc; i++) {
		if (strlen(argv[i]) == 0) continue;
		switch (argv[i][0]) {
		case '-':
			if (strlen(argv[i]) != 2) use();
			switch (argv[i][1]) {
			case 'e':
				tape_extract = 1;
				break;
			case 'd':
				if (i+1<argc) {
					extract_directory = argv[i+1];
					i++;
				}
				else use();
				break;
			case '?':
			case 'h':
				show_help();
				break;
			default:
				use();
				break;
			}
			break;

		default:
			decode_tape(argv[i], extract_directory, tape_extract, tape_catalogue);
			break;
		}
	}
}
